Option Strict On

Public Class Form1

    'Dim objOL As Object = GetObject(, "Outlook.Application") - if you want to do late-binding
    Dim objOL As New Microsoft.Office.Interop.Outlook.Application

    ''' <summary>
    ''' Handle the DragDrop event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Label1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Label1.DragDrop
        lblFile.Text = String.Empty
        Try

            If e.Data.GetDataPresent(DataFormats.FileDrop) Then
                'supports a drop of a file from Windows Explorer

                ' copy the name of the dragged files into a string array
                Dim draggedFiles As String() = CType(e.Data.GetData(DataFormats.FileDrop), String())

                'handle each file passed as needed
                For Each fileName As String In draggedFiles
                    'hardcode a destination path for testing
                    Dim strDestinationFile As String = _
                                IO.Path.Combine("c:\temp", _
                                                IO.Path.GetFileName(fileName))
                    'test if source and destination are the same
                    If strDestinationFile.Trim.ToUpper = fileName.Trim.ToUpper Then
                        lblFile.Text += strDestinationFile + _
                                        " - Source and Destination are the same!!!" + _
                                        Environment.NewLine
                    Else
                        lblFile.Text += "Copying - " + _
                                        strDestinationFile + Environment.NewLine
                        IO.File.Copy(fileName, strDestinationFile)
                    End If
                Next

            ElseIf e.Data.GetDataPresent("FileGroupDescriptor") Then
                'supports a drop of a Outlook message

                'Dim objMI As Object - if you want to do late-binding
                Dim objMI As Microsoft.Office.Interop.Outlook.MailItem

                For Each objMI In objOL.ActiveExplorer.Selection()
                    'hardcode a destination path for testing
                    Dim strFile As String = _
                                IO.Path.Combine("c:\temp", _
                                                (objMI.Subject + ".msg").Replace(":", ""))
                    lblFile.Text += strFile + Environment.NewLine
                    objMI.SaveAs(strFile)
                Next
            End If
            lblFormat.Text = String.Empty

        Catch ex As Exception
            lblFile.Text = "An error occured in the drop event" + Environment.NewLine + ex.ToString
        End Try
    End Sub

    ''' <summary>
    ''' Reset the status label
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Label1_DragLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Label1.DragLeave
        lblFormat.Text = String.Empty
    End Sub

    ''' <summary>
    ''' Handle the DragOver event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Label1_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Label1.DragOver
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            'handle a file dragged from Windows explorer
            e.Effect = DragDropEffects.Copy
            lblFormat.Text = "DragOver ... File drop"
        ElseIf e.Data.GetDataPresent("FileGroupDescriptor") Then
            'handle a message dragged from Outllok
            e.Effect = DragDropEffects.Copy
            lblFormat.Text = "DragOver ... Outlook"
        Else
            'otherwise, do not handle
            e.Effect = DragDropEffects.None
            lblFormat.Text = ""
        End If
    End Sub

End Class
